
// Приведите пару примеров, когда уместно использовать в коде конструкцию try...catch.

// Дан массив books.

// Выведите этот массив на экран в виде списка (тег ul 
// - список должен быть сгенерирован с помощью Javascript).
// На странице должен находиться div с id="root", куда и нужно будет положить 
// \этот список (похожая задача была дана в модуле basic).
// Перед выводом обьекта на странице, нужно проверить его на корректность 
// (в объекте должны содержаться все три свойства - author, name, price). 
// Если какого-то из этих свойств нету, в консоли должна высветиться ошибка 
// с указанием - какого свойства нету в обьекте.
// Те элементы массива, которые являются некорректными по условиям 
// предыдущего пункта, не должны появиться на странице.

const books = [
    { 
      author: "Скотт Бэккер",
      name: "Тьма, что приходит прежде",
      price: 70 
    }, 
    {
     author: "Скотт Бэккер",
     name: "Воин-пророк",
    }, 
    { 
      name: "Тысячекратная мысль",
      price: 70
    }, 
    { 
      author: "Скотт Бэккер",
      name: "Нечестивый Консульт",
      price: 70
    }, 
    {
     author: "Дарья Донцова",
     name: "Детектив на диете",
     price: 40
    },
    {
     author: "Дарья Донцова",
     name: "Дед Снегур и Морозочка",
    }
  ];

let root = document.getElementById('root');
let ul = document.createElement('ul');
root.append(ul);

function renderList(obj) {
    let {author, name, price} = obj;
    let li = `<li>${name}<ul><li> Автор: ${author} <li>Цена: ${price}</li></li></ul></li>`;

    try {
        if (!name || !price || !author) throw new Error('Объект не содержит полный список данных')
    }
    catch(error) {
        if (error) {
            console.error(`${error.message}`);
            return
        }
    }
    ul.innerHTML += li;
}

books.forEach(item => renderList(item));







  